
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "FFT.h"

int	SetUpFFT(N,E)
int	N;
Complex	**E;
{
	int	L,l;
	Complex	*e;
	double	d,a;

	for (L=1; L<N; L<<=1) ;

	if ((*E=(Complex *)malloc(L*sizeof(**E)))==NULL) return 0;

	d=M_PI/(double)L;
	for (e=(*E), l=0; l<L; l++, e++) {
	    a=d*(double)l; e->r=cos(a); e->i=sin(a);
	}
	return L;
}

void	FFT(L,E,Z,S)
int	L,S;
Complex	*E,*Z;
{
	int	j,k,m,n,p,q,L1=L-1,L2=L>>1;
	Complex	z,*e,*x,*y;
	double	c,s,r,i;

	for (j=1; j<L1; j++) {
	    k=0; for (m=L2, n=1; n<=j; n<<=1, m>>=1) if (j&n) k|=m;
	    if (j<k) {
		z=Z[j]; Z[j]=Z[k]; Z[k]=z;
	    }
	}
	for (j=2, k=1, m=L2, n=L; n>1; n=m, m>>=1, k=j, j<<=1)
	    for (e=E, p=0; p<k; p++, e+=n) {
		c=e->r; s=e->i*(double)S;
		for (x=Z+p, q=0; q<m; q++, x+=j) {
		    y=x+k; r=y->r*c-y->i*s;
			   i=y->r*s+y->i*c; y->r=x->r-r; x->r+=r;
					    y->i=x->i-i; x->i+=i;
		}
	    }
}

void	ClearFFT(E)
Complex	*E;
{
	free(E);
}
