
#include <stdio.h>
#include <stdlib.h>
#include "FFT.h"

extern void	Error(char *);

#define LEN	2048

int	main(int argc,char **argv)
{
	char	*p,S[LEN],*dre="data read error.";
	int	s,Nx,Ny,Lx,Ly,y,x;
	Complex	*Ex,*Ey,**C,*Y;

	for (p=argv[0]; *p!='\0'; p++) ;
	while (--p>=argv[0] && *p!='/' && *p!='\\') ;
	s=(p[1]=='i' || p[1]=='I')?-1:1;

	if (fgets(S,LEN,stdin)==NULL ||
	    sscanf(S,"%d %d",&Nx,&Ny)!=2 || Nx<=0 || Ny<=0)
	    Error("bad data number.");

	if ((Lx=SetUpFFT(Nx,&Ex))==0 ||
	    (Ly=SetUpFFT(Ny,&Ey))==0 ||
	    (C=(Complex **)malloc(sizeof(Complex *)*Ly))==NULL ||
	    (*C=(Complex *)malloc(sizeof(Complex)*Ly*Lx))==NULL ||
	    (Y=(Complex *)malloc(sizeof(Complex)*Ly))==NULL)
	    Error("memory allocation error.");

	for (y=0; y<Ly; y++) {
	    if (y>0) C[y]=C[y-1]+Lx;

	    if (y>=Ny)
		for (x=0; x<Lx; x++) C[y][x].r=C[y][x].i=0.0;
	    else {
		for (x=0; x<Lx; x++)
		    if (x>=Nx)
			C[y][x].r=C[y][x].i=0.0;
		    else {
			if (fgets(S,LEN,stdin)==NULL) Error(dre);

			switch(sscanf(S,"%lf %lf",&(C[y][x].r),&(C[y][x].i))) {
			    case 1 : C[y][x].i=0.0; break;
			    case 2 : break;
			    default: Error(dre);
			}
		    }

		FFT(Lx,Ex,C[y],s);
	    }
	}
	for (x=0; x<Lx; x++) {
	    for (y=0; y<Ly; y++) Y[y]=C[y][x]; FFT(Ly,Ey,Y,s);
	    for (y=0; y<Ly; y++) C[y][x]=Y[y];
	}
	(void)printf("%d\t%d\n",Lx,Ly);
	for (y=0; y<Ly; y++)
	for (x=0; x<Lx; x++)
	    (void)printf("%18.16lf\t%18.16lf\n",C[y][x].r,C[y][x].i);

	return 0;
}
