
#include <stdio.h>
#include <stdlib.h>
#include "FFT.h"

extern void	Error(char *);

#define LEN	2048

int	main(int argc,char **argv)
{
	char	*p,S[LEN],*dre="data read error.";
	int	s,Nx,Ny,Nz,Lx,Ly,Lz,z,y,x;
	Complex	*Ex,*Ey,*Ez,***C,*YZ;

	for (p=argv[0]; *p!='\0'; p++) ;
	while (--p>=argv[0] && *p!='/' && *p!='\\') ;
	s=(p[1]=='i' || p[1]=='I')?-1:1;

	if (fgets(S,LEN,stdin)==NULL ||
	    sscanf(S,"%d %d %d",&Nx,&Ny,&Nz)!=3 || Nx<=0 || Ny<=0 || Nz<=0)
	    Error("bad data number.");

	if ((Lx=SetUpFFT(Nx,&Ex))==0 ||
	    (Ly=SetUpFFT(Ny,&Ey))==0 ||
	    (Lz=SetUpFFT(Nz,&Ez))==0 ||
	    (C=(Complex ***)malloc(sizeof(Complex **)*Lz))==NULL ||
	    (*C=(Complex **)malloc(sizeof(Complex *)*Lz*Ly))==NULL ||
	    (**C=(Complex *)malloc(sizeof(Complex)*Lz*Ly*Lx))==NULL ||
	    (YZ=(Complex *)malloc(sizeof(Complex)*((Ly>Lz)?Ly:Lz)))==NULL)
	    Error("memory allocation error.");

	for (z=0; z<Lz; z++) {
	    if (z>0) {
		C[z]=C[z-1]+Ly;
		C[z][0]=C[z-1][Ly-1]+Lx;
	    }
	    for (y=1; y<Ly; y++) C[z][y]=C[z][y-1]+Lx;

	    if (z>=Nz)
		for (y=0; y<Ly; y++)
		for (x=0; x<Lx; x++) C[z][y][x].r=C[z][y][x].i=0.0;
	    else {
		for (y=0; y<Ly; y++)
		    if (y>=Ny)
			for (x=0; x<Lx; x++) C[z][y][x].r=C[z][y][x].i=0.0;
		    else {
			for (x=0; x<Lx; x++)
			    if (x>=Nx)
				C[z][y][x].r=C[z][y][x].i=0.0;
			    else {
				if (fgets(S,LEN,stdin)==NULL) Error(dre);

				switch(sscanf(S,"%lf %lf",&(C[z][y][x].r),
							  &(C[z][y][x].i))) {
				    case 1 : C[z][y][x].i=0.0; break;
				    case 2 : break;
				    default: Error(dre);
				}
			    }

			FFT(Lx,Ex,C[z][y],s);
		    }

		for (x=0; x<Lx; x++) {
		    for (y=0; y<Ly; y++) YZ[y]=C[z][y][x]; FFT(Ly,Ey,YZ,s);
		    for (y=0; y<Ly; y++) C[z][y][x]=YZ[y];
		}
	    }
	}
	for (y=0; y<Ly; y++)
	for (x=0; x<Lx; x++) {
	    for (z=0; z<Lz; z++) YZ[z]=C[z][y][x]; FFT(Lz,Ez,YZ,s);
	    for (z=0; z<Lz; z++) C[z][y][x]=YZ[z];
	}
	(void)printf("%d\t%d\t%d\n",Lx,Ly,Lz);
	for (z=0; z<Lz; z++)
	for (y=0; y<Ly; y++)
	for (x=0; x<Lx; x++)
	    (void)printf("%18.16lf\t%18.16lf\n",C[z][y][x].r,C[z][y][x].i);

	return 0;
}
